diff mbox series

[3/4] fstests: individual user grace period extension via setquota

Message ID 26777fcb-2fff-0928-bc20-e43eb069dbdd@redhat.com (mailing list archive)
State Accepted
Headers show
Series fstests: more quota related tests | expand

Commit Message

Eric Sandeen May 18, 2020, 8 p.m. UTC
Test that we can extend an individual user's grace time once they
reach their soft limit.

Signed-off-by: Eric Sandeen <sandeen@redhat.com>
---
 tests/generic/903     | 67 +++++++++++++++++++++++++++++++++++++++++++
 tests/generic/903.out |  1 +
 tests/generic/group   |  1 +
 3 files changed, 69 insertions(+)
 create mode 100755 tests/generic/903
 create mode 100644 tests/generic/903.out
diff mbox series

Patch

diff --git a/tests/generic/903 b/tests/generic/903
new file mode 100755
index 00000000..1903755e
--- /dev/null
+++ b/tests/generic/903
@@ -0,0 +1,67 @@ 
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 Red Hat, Inc.  All Rights Reserved.
+#
+# FS QA Test No. 903
+#
+# Test individual user ID quota grace period extension
+# This is the linux quota-tools version of the test
+#
+# This test only exercises user quota because it's not known whether the
+# filesystem can set individual grace timers for each quota type
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/quota
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+_require_scratch
+_require_quota
+_require_user
+_require_setquota_project
+
+_scratch_mkfs >$seqres.full 2>&1
+_qmount_option "usrquota"
+_qmount
+
+# Set a default user inode grace period of 1 second
+setquota -t -u 0 1 $SCRATCH_MNT
+# Soft inode limit 1, hard limit 5
+setquota -u $qa_user 0 0 1 5 $SCRATCH_MNT
+# Run qa user over soft limit and go over grace period
+su $qa_user -c "touch $SCRATCH_MNT/file1 $SCRATCH_MNT/file2"
+sleep 3
+# Extend grace to now + 100s
+now=`date +%s`
+let set=now+100
+setquota -T -u $qa_user 0 100 $SCRATCH_MNT 2>&1 | grep -v "^setquota"
+get=`repquota -up $SCRATCH_MNT | grep  "^$qa_user" | awk '{print $NF}'`
+
+if [ "$get" != "$set" ]; then
+	echo "set grace to $set but got grace $get"
+fi
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/903.out b/tests/generic/903.out
new file mode 100644
index 00000000..c0f7f92a
--- /dev/null
+++ b/tests/generic/903.out
@@ -0,0 +1 @@ 
+QA output created by 903
diff --git a/tests/generic/group b/tests/generic/group
index 66e71a70..ab1b4b8f 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -602,3 +602,4 @@ 
 900 auto quick perms
 901 auto quick perms
 902 auto quick quota
+903 auto quick quota